diff --git a/src/town.h b/src/town.h
--- a/src/town.h
+++ b/src/town.h
@@ -34,6 +34,37 @@
 typedef Pool<Town, TownID, 64, 64000> TownPool;
 extern TownPool _town_pool;
 
+/**
+ * How hard do we want the number of required cargo
+ * for the towns to be able to grow at max rate.
+ */
+static const uint8 _difficulty_town_needed_for_growth[] = {
+	2,   // Off (@note: this value is never used but if defined as zero the game will crash !!).
+	2,   // Very Easy.
+	3,   // Easy.
+	4,   // Average.
+	5,   // Hard.
+	6,   // very hard.
+	10,  // Drive me nuts please.
+};
+
+/** What is needed for town growth. */
+enum TownNeededForGrowth {
+	GROWTH_STANDARD,
+	GROWTH_NEED_STATION,
+	GROWTH_NEED_MORE_PASS,
+	GROWTH_NEED_MORE_MAIL,
+	GROWTH_NEED_MORE_FOOD,
+	GROWTH_NEED_MORE_WATER,
+	GROWTH_NEED_MORE_GOODS,
+	GROWTH_NEED_PASS,
+	GROWTH_NEED_MAIL,
+	GROWTH_NEED_FOOD,
+	GROWTH_NEED_WATER,
+	GROWTH_NEED_GOODS,
+	GROWTH_SATISFIED,
+};
+
 /** Town data structure. */
 struct Town : TownPool::PoolItem<&_town_pool> {
 	TileIndex xy;                  ///< town center tile
@@ -116,6 +147,55 @@
 
 	void InitializeLayout(TownLayout layout);
 
+	void UpdateLabel();
+
+	/**
+	 * Returns the correct town label, based on rating.
+	 */
+	FORCEINLINE StringID Label() const{
+		if (!(_game_mode == GM_EDITOR) && (_local_company < MAX_COMPANIES)) {
+			/**
+			 * <)- Option to display population string always in white.
+			 *
+			 * Little bit of a hack here: we abuse the fact that the very good string is white
+			 * @note By doing this here we do not mess with actual company rating.
+			 */
+			if (_settings_client.gui.population_in_label) {
+				if (!_settings_client.gui.population_in_label_coloured) {
+					return STR_VIEWPORT_TOWN_POP;
+				} else {
+					return STR_VIEWPORT_TOWN_POP_VERY_POOR_RATING + this->town_label;
+				}			
+			} else {
+				return STR_VIEWPORT_TOWN;
+			}
+		} else {
+			return STR_VIEWPORT_TOWN;
+		}
+	}
+		
+	/**
+	 * Returns the correct town small label, based on rating.
+	 */
+	FORCEINLINE StringID SmallLabel() const{
+		if (!(_game_mode == GM_EDITOR) && (_local_company < MAX_COMPANIES)) {
+			/**
+			 * <)- Option to display population string always in white.
+			 *
+			 * Little bit of a hack here: we abuse the fact that the very good string is white
+			 * 
+			 * @note By doing this here we do not mess with actual company rating.
+			 */
+			if (_settings_client.gui.population_in_label_coloured && _settings_client.gui.population_in_label) {
+				return STR_VIEWPORT_TOWN_TINY_VERY_POOR_RATING + this->town_label;
+			} else {
+				return STR_VIEWPORT_TOWN_TINY_WHITE;
+			}
+		} else {
+			return STR_VIEWPORT_TOWN_TINY_WHITE;
+		}
+	}
+
 	/**
 	 * Calculate the max town noise.
 	 * The value is counted using the population divided by the content of the
@@ -139,6 +219,44 @@
 
 	static Town *GetRandom();
 	static void PostDestructor(size_t index);
+
+	/* Growthrate displayed in the gui.
+	 * 100% is normal growth rate. */
+	inline uint16 GrowthRatePercent() const {
+		int16 default_growth_rate = 320;
+		uint growth_multiplier = _settings_game.economy.town_growth_rate != 0 ? _settings_game.economy.town_growth_rate - 1 : 1;
+		default_growth_rate >>= growth_multiplier;
+		default_growth_rate /= (num_houses / 50 + 1);
+		if (larger_town) default_growth_rate /= 2;
+		/* If some required cargotypes are not transported return 1.
+		 * If growth patch is off or town is too small to demand goods calculate normally. */
+		if (((!larger_town && _settings_game.economy.town_growth_cargo) || (larger_town && _settings_game.economy.larger_town_growth_cargo))&&
+				((!larger_town && population > _settings_game.economy.town_pop_need_goods) ||
+				(larger_town && population > _settings_game.economy.larger_town_pop_need_goods))) {
+			if ((_settings_game.game_creation.landscape == LT_TEMPERATE ||
+					_settings_game.game_creation.landscape == LT_TOYLAND ||
+					(_settings_game.game_creation.landscape == LT_ARCTIC && TilePixelHeight(this->xy) < GetSnowLine()) ||
+					(_settings_game.game_creation.landscape == LT_TROPIC && GetTropicZone(this->xy) == TROPICZONE_DESERT)) &&
+					(act_pass == 0 || act_mail == 0 || act_goods == 0)) {
+				return 1;
+			} else if (_settings_game.game_creation.landscape == LT_ARCTIC &&
+					TilePixelHeight(this->xy) >= GetSnowLine() &&
+					(act_pass == 0 || act_mail == 0 || act_goods == 0 || act_food == 0)) {
+				return 1;		
+			} else if (_settings_game.game_creation.landscape == LT_TROPIC &&
+					GetTropicZone(this->xy) == TROPICZONE_DESERT &&
+					(act_pass == 0 || act_mail == 0 || act_goods == 0  || act_food == 0|| act_water == 0)) {
+				return 1;
+			} else {
+				return 320 * this->transported_goods_percent / 100;
+			}
+		} else {
+			return (uint16)((1 / (double)growth_rate) * default_growth_rate * 320);
+		}
+	}
+
+	byte transported_goods_percent; ///< Percentage of transported goods last month.
+	byte needed_for_growth;	        ///< What is most needed for town growth?
 };
 
 uint32 GetWorldPopulation();
@@ -183,7 +301,8 @@
 void ResetHouses();
 
 void ClearTownHouse(Town *t, TileIndex tile);
-void UpdateTownMaxPass(Town *t);
+void UpdateTownGenCargo(Town *t);
+void UpdateTownDemands(Town *t);
 void UpdateTownRadius(Town *t);
 CommandCost CheckIfAuthorityAllowsNewStation(TileIndex tile, DoCommandFlag flags);
 Town *ClosestTownFromTile(TileIndex tile, uint threshold);
@@ -193,7 +312,6 @@
 uint GetMaskOfTownActions(int *nump, CompanyID cid, const Town *t);
 bool GenerateTowns(TownLayout layout);
 
-
 /** Town actions of a company. */
 enum TownActions {
 	TACT_NONE             = 0x00, ///< Empty action set.
diff --git a/src/town_cmd.cpp b/src/town_cmd.cpp
--- a/src/town_cmd.cpp
+++ b/src/town_cmd.cpp
@@ -160,6 +160,26 @@
 }
 
 /**
+ * Updates the town label of the town after changes in rating. The colour scheme is:
+ * Red: Appalling and Very poor ratings.
+ * Orange: Poor and mediocre ratings.
+ * Yellow: Good rating.
+ * White: Very good rating (standard).
+ * Green: Excellent and outstanding ratings.
+ */
+void Town::UpdateLabel()
+{
+	if (!(_game_mode == GM_EDITOR) && (_local_company < MAX_COMPANIES)) {
+		int r = this->ratings[_local_company];
+		(this->town_label = 0, r <= RATING_VERYPOOR)  || // Appalling and Very Poor
+		(this->town_label++,   r <= RATING_MEDIOCRE)  || // Poor and Mediocre
+		(this->town_label++,   r <= RATING_GOOD)      || // Good
+		(this->town_label++,   r <= RATING_VERYGOOD)  || // Very Good
+		(this->town_label++,   true);                    // Excellent and Outstanding
+	}
+}
+
+/**
  * Get the cost for removing this house
  * @return the cost (inflation corrected etc)
  */
@@ -352,11 +372,11 @@
  */
 void Town::UpdateVirtCoord()
 {
+	this->UpdateLabel();
 	Point pt = RemapCoords2(TileX(this->xy) * TILE_SIZE, TileY(this->xy) * TILE_SIZE);
 	SetDParam(0, this->index);
 	SetDParam(1, this->population);
-	this->sign.UpdatePosition(pt.x, pt.y - 24,
-		_settings_client.gui.population_in_label ? STR_VIEWPORT_TOWN_POP : STR_VIEWPORT_TOWN);
+	this->sign.UpdatePosition(pt.x, pt.y - 24, this->Label());
 
 	SetWindowDirty(WC_TOWN_VIEW, this->index);
 }
@@ -436,6 +456,61 @@
 }
 
 /**
+ * Generate cargo for a town (house).
+ *
+ * The amount of cargo should be and will be greater than zero.
+ *
+ * @param t current town
+ * @param ct type of cargo to generate, usually CT_PASSENGERS or CT_MAIL
+ * @param amount how many units of cargo
+ * @param stations available stations for this house
+ */
+static void TownGenerateCargo (Town *t, CargoID ct, uint amount, StationFinder &stations)
+{
+	/* custom cargo generation factor */
+	int cf = _settings_game.economy.town_cargo_factor;
+
+	/* when the economy flunctuates, everyone wants to stay at home */
+	if (EconomyIsInRecession())
+		amount = (amount + 1) >> 1; 
+	
+	/* apply custom factor? */
+	if (cf < 0) {
+		/* approx (amount / 2^cf)
+		 * adjust with a constant offset of {(2 ^ cf) - 1} (i.e. add cf * 1-bits) before dividing to ensure that it doesn't become zero
+		 * this skews the curve a little so that isn't entirely exponential, but will still decrease */
+		amount = (amount + ((1 << -cf) - 1)) >> -cf;
+	} else if (cf > 0) {
+		/* approx (amount * 2^cf) */
+		/* XXX: overflow? */
+		amount = amount << cf;
+	}
+
+	/* with the adjustments above, this should never happen */
+	assert(amount > 0);
+	
+	/* send cargo to station */
+	uint moved = MoveGoodsToStation(ct, amount, ST_TOWN, t->index, stations.GetStations());
+	
+	/* calculate for town stats */
+	const CargoSpec *cs = CargoSpec::Get(ct);
+	switch (cs->town_effect) {
+		case TE_PASSENGERS:
+			t->new_gen_max_pass += amount;
+			t->new_gen_act_pass += moved;
+			break;
+
+		case TE_MAIL:
+			t->new_gen_max_mail += amount;
+			t->new_gen_act_mail += moved;
+			break;
+
+		default:
+			break;
+	}
+}
+
+/**
  * Tile callback function.
  *
  * Periodic tic handler for houses and town
@@ -487,15 +562,32 @@
 			const CargoSpec *cs = CargoSpec::Get(cargo);
 			switch (cs->town_effect) {
 				case TE_PASSENGERS:
+					TownGenerateCargo(t, cargo, amt, stations); // XXX: no economy flunctuation for GRF cargos?
 					t->new_max_pass += amt;
 					t->new_act_pass += moved;
 					break;
 
 				case TE_MAIL:
+					TownGenerateCargo(t, cargo, amt, stations); // XXX: no economy flunctuation for GRF cargos?
 					t->new_max_mail += amt;
 					t->new_act_mail += moved;
 					break;
 
+				case TE_FOOD:
+					t->new_max_food += amt;
+					t->new_act_food += moved;
+					break;
+
+				case TE_WATER:
+					t->new_max_water += amt;
+					t->new_act_water += moved;
+					break;
+
+				case TE_GOODS:
+					t->new_max_goods += amt;
+					t->new_act_goods += moved;
+					break;
+
 				default:
 					break;
 			}
@@ -503,19 +595,17 @@
 	} else {
 		if (GB(r, 0, 8) < hs->population) {
 			uint amt = GB(r, 0, 8) / 8 + 1;
-
-			if (EconomyIsInRecession()) amt = (amt + 1) >> 1;
-			t->new_max_pass += amt;
-			t->new_act_pass += MoveGoodsToStation(CT_PASSENGERS, amt, ST_TOWN, t->index, stations.GetStations());
+			
+			TownGenerateCargo(t, CT_PASSENGERS, amt, stations);
 		}
 
 		if (GB(r, 8, 8) < hs->mail_generation) {
 			uint amt = GB(r, 8, 8) / 8 + 1;
 
-			if (EconomyIsInRecession()) amt = (amt + 1) >> 1;
-			t->new_max_mail += amt;
-			t->new_act_mail += MoveGoodsToStation(CT_MAIL, amt, ST_TOWN, t->index, stations.GetStations());
+			TownGenerateCargo(t, CT_MAIL, amt, stations);
 		}
+
+		UpdateTownDemands(t);
 	}
 
 	Backup<CompanyByte> cur_company(_current_company, OWNER_TOWN, FILE_LINE);
@@ -523,7 +613,7 @@
 	if ((hs->building_flags & BUILDING_HAS_1_TILE) &&
 			HasBit(t->flags, TOWN_IS_FUNDED) &&
 			CanDeleteHouse(tile) &&
-			GetHouseAge(tile) >= hs->minimum_life &&
+			GetHouseAge(tile) >= (hs->minimum_life  * _date_daylength_factor) &&
 			--t->time_until_rebuild == 0) {
 		t->time_until_rebuild = GB(r, 16, 8) + 192;
 
@@ -1399,10 +1489,52 @@
 	}
 }
 
-void UpdateTownMaxPass(Town *t)
+/**
+ * Calculates town generated cargo.
+ * @param t This Town.
+ */
+void UpdateTownGenCargo(Town *t)
 {
-	t->max_pass = t->population >> 3;
-	t->max_mail = t->population >> 4;
+	t->gen_max_pass = t->population >> 3;
+	t->gen_max_mail = t->population >> 4;
+}
+
+ /**
+ * Calculate demanded goods for towngrowth.
+ * @param t This town.
+ */
+void UpdateTownDemands(Town *t)
+{
+	byte dtg;
+	if(!t->larger_town) {
+		dtg = _difficulty_town_needed_for_growth[_settings_game.economy.town_growth_cargo];
+	} else {
+		dtg = _difficulty_town_needed_for_growth[_settings_game.economy.larger_town_growth_cargo];
+	}
+	int cf = _settings_game.economy.town_cargo_factor;
+	uint popul = t->population;
+	if (t->larger_town) popul *= 2;
+
+	/* Devided by 4 before multiplying by difficulty so that "average" can be equal to max generated passengers and mail. */
+	t->max_pass = ((popul >> 3) / 4 * dtg) * _date_daylength_factor;
+	t->max_mail = ((popul >> 4) / 4 * dtg) * _date_daylength_factor;
+	/* Apply town cargo generation factor for passengers and mail too. */
+	if (cf < 0) {
+		/* approx (amount / 2^cf)
+		 * adjust with a constant offset of {(2 ^ cf) - 1} (i.e. add cf * 1-bits) before dividing to ensure that it doesn't become zero
+		 * this skews the curve a little so that isn't entirely exponential, but will still decrease */
+		t->max_pass = (t->max_pass + ((1 << -cf) - 1)) >> -cf;
+		t->max_mail = (t->max_mail + ((1 << -cf) - 1)) >> -cf;
+	} else if (cf > 0) {
+		/* approx (amount * 2^cf) */
+		/* XXX: overflow? */
+		t->max_pass = t->max_pass << cf;
+		t->max_mail = t->max_mail << cf;
+	}
+
+	t->max_food = ((popul >> 2) / 7 / 4) * dtg;
+	t->max_water = ((popul >> 4) * 5 / 9 / 4) * dtg;
+	t->max_goods = ((popul >> 2) / 5 / 4) * dtg;
 }
 
 /**
@@ -1482,7 +1614,8 @@
 
 	t->num_houses -= x;
 	UpdateTownRadius(t);
-	UpdateTownMaxPass(t);
+	UpdateTownGenCargo(t);
+	UpdateTownDemands(t);
 	UpdateAirportsNoise();
 }
 
@@ -2249,6 +2382,7 @@
 static void DoClearTownHouseHelper(TileIndex tile, Town *t, HouseID house)
 {
 	assert(IsTileType(tile, MP_HOUSE));
+
 	DecreaseBuildingCount(t, house);
 	DoClearSquare(tile);
 	DeleteAnimatedTile(tile);
@@ -2375,7 +2509,8 @@
 		t->num_houses -= amount;
 		UpdateTownRadius(t);
 
-		UpdateTownMaxPass(t);
+		UpdateTownGenCargo(t);
+		UpdateTownDemands(t);
 	}
 
 	return CommandCost();
@@ -2593,7 +2728,7 @@
 	if (!_settings_game.economy.exclusive_rights) return CMD_ERROR;
 
 	if (flags & DC_EXEC) {
-		t->exclusive_counter = 12;
+		t->exclusive_counter = 12 * _date_daylength_factor;
 		t->exclusivity = _current_company;
 
 		ModifyStationRatingAround(t->xy, _current_company, 130, 17);
@@ -2626,6 +2761,7 @@
 			 */
 			if (t->ratings[_current_company] > RATING_BRIBE_DOWN_TO) {
 				t->ratings[_current_company] = RATING_BRIBE_DOWN_TO;
+				t->UpdateVirtCoord();
 				SetWindowDirty(WC_TOWN_AUTHORITY, t->index);
 			}
 		} else {
@@ -2758,6 +2894,7 @@
 		t->ratings[i] = Clamp(t->ratings[i], RATING_MINIMUM, RATING_MAXIMUM);
 	}
 
+	t->UpdateVirtCoord();
 	SetWindowDirty(WC_TOWN_AUTHORITY, t->index);
 
 	ClrBit(t->flags, TOWN_IS_FUNDED);
@@ -2983,6 +3120,7 @@
 	} else {
 		SetBit(t->have_ratings, _current_company);
 		t->ratings[_current_company] = rating;
+		t->UpdateVirtCoord();
 		SetWindowDirty(WC_TOWN_AUTHORITY, t->index);
 	}
 }
diff --git a/src/town_gui.cpp b/src/town_gui.cpp
--- a/src/town_gui.cpp
+++ b/src/town_gui.cpp
@@ -362,20 +362,11 @@
 	{
 		if (widget != TVW_INFOPANEL) return;
 
+		StringID str;
 		uint y = r.top + WD_FRAMERECT_TOP;
 
-		SetDParam(0, this->town->population);
-		SetDParam(1, this->town->num_houses);
-		DrawString(r.left + WD_FRAMERECT_LEFT, r.right - WD_FRAMERECT_LEFT, y, STR_TOWN_VIEW_POPULATION_HOUSES);
-
-		SetDParam(0, this->town->act_pass);
-		SetDParam(1, this->town->max_pass);
-		DrawString(r.left + WD_FRAMERECT_LEFT, r.right - WD_FRAMERECT_LEFT, y += FONT_HEIGHT_NORMAL, STR_TOWN_VIEW_PASSENGERS_LAST_MONTH_MAX);
-
-		SetDParam(0, this->town->act_mail);
-		SetDParam(1, this->town->max_mail);
-		DrawString(r.left + WD_FRAMERECT_LEFT, r.right - WD_FRAMERECT_LEFT, y += FONT_HEIGHT_NORMAL, STR_TOWN_VIEW_MAIL_LAST_MONTH_MAX);
-
+/* needed for old style gui 1/2 */
+		/* Required delivered cargos for growth in artic and tropic climate. */
 		StringID required_text = STR_TOWN_VIEW_CARGO_FOR_TOWNGROWTH_REQUIRED;
 		uint cargo_needed_for_growth = 0;
 		switch (_settings_game.game_creation.landscape) {
@@ -390,45 +381,193 @@
 
 			default: break;
 		}
+/* needed for old style gui 1/2 end*/
 
-		if (cargo_needed_for_growth > 0) {
-			DrawString(r.left + WD_FRAMERECT_LEFT, r.right - WD_FRAMERECT_LEFT, y += FONT_HEIGHT_NORMAL, STR_TOWN_VIEW_CARGO_FOR_TOWNGROWTH);
+		/* Needed for cases where the towneffect of cargos is changed by means of GRF. */
+		const CargoSpec *passengers = FindFirstCargoWithTownEffect(TE_PASSENGERS);
+		StringID passengers_name    = (passengers != NULL) ? passengers->name    : STR_CARGO_PLURAL_PASSENGERS;
 
-			bool rtl = _current_text_dir == TD_RTL;
-			uint cargo_text_left = r.left + WD_FRAMERECT_LEFT + (rtl ? 0 : 20);
-			uint cargo_text_right = r.right - WD_FRAMERECT_RIGHT - (rtl ? 20 : 0);
+		const CargoSpec *mail       = FindFirstCargoWithTownEffect(TE_MAIL);
+		StringID mail_name          = (mail != NULL) ? mail->name    : STR_CARGO_PLURAL_MAIL;
 
-			const CargoSpec *food = FindFirstCargoWithTownEffect(TE_FOOD);
-			CargoID first_food_cargo = (food != NULL) ? food->Index() : (CargoID)CT_INVALID;
-			StringID food_name       = (food != NULL) ? food->name    : STR_CARGO_PLURAL_FOOD;
+		const CargoSpec *food = FindFirstCargoWithTownEffect(TE_FOOD);
+		CargoID first_food_cargo = (food != NULL) ? food->Index() : (CargoID)CT_INVALID;
+		StringID food_name       = (food != NULL) ? food->name    : STR_CARGO_PLURAL_FOOD;
 
-			const CargoSpec *water = FindFirstCargoWithTownEffect(TE_WATER);
-			CargoID first_water_cargo = (water != NULL) ? water->Index() : (CargoID)CT_INVALID;
-			StringID water_name       = (water != NULL) ? water->name    : STR_CARGO_PLURAL_WATER;
+		const CargoSpec *water = FindFirstCargoWithTownEffect(TE_WATER);
+		CargoID first_water_cargo = (water != NULL) ? water->Index() : (CargoID)CT_INVALID;
+		StringID water_name       = (water != NULL) ? water->name    : STR_CARGO_PLURAL_WATER;
 
-			if (first_food_cargo != CT_INVALID && this->town->act_food > 0) {
-				SetDParam(0, first_food_cargo);
-				SetDParam(1, this->town->act_food);
-				DrawString(cargo_text_left, cargo_text_right, y += FONT_HEIGHT_NORMAL, STR_TOWN_VIEW_CARGO_FOR_TOWNGROWTH_LAST_MONTH);
-			} else {
-				SetDParam(0, food_name);
-				DrawString(cargo_text_left, cargo_text_right, y += FONT_HEIGHT_NORMAL, required_text);
+		const CargoSpec *goods      = FindFirstCargoWithTownEffect(TE_GOODS);
+		StringID goods_name         = (goods != NULL) ? goods->name    : STR_CARGO_PLURAL_GOODS;
+
+		/* Population and number of houses. */
+		SetDParam(0, this->town->population);
+		SetDParam(1, this->town->num_houses);
+		DrawString(r.left + WD_FRAMERECT_LEFT, r.right - WD_FRAMERECT_LEFT, y, STR_TOWN_VIEW_POPULATION_HOUSES);
+
+		/* Empty line. */
+		DrawString(r.left + WD_FRAMERECT_LEFT, r.right - WD_FRAMERECT_LEFT, y += FONT_HEIGHT_NORMAL, STR_EMPTY);
+
+		/* Generated cargo titel. */
+		DrawString(r.left + WD_FRAMERECT_LEFT, r.right - WD_FRAMERECT_LEFT, y += FONT_HEIGHT_NORMAL, STR_TOWN_VIEW_GENERATED_CARGO_LAST_MONTH);
+
+		/* Generated and max possible generated passengers. */
+		SetDParam(0, this->town->gen_act_pass);
+		SetDParam(1, this->town->gen_max_pass);
+		DrawString(r.left + WD_FRAMERECT_LEFT, r.right - WD_FRAMERECT_LEFT, y += FONT_HEIGHT_NORMAL, STR_TOWN_VIEW_GENERATED_PASS_LAST_MONTH_MAX);
+
+		/* Generated and max possible generated mail. */
+		SetDParam(0, this->town->gen_act_mail);
+		SetDParam(1, this->town->gen_max_mail);
+		DrawString(r.left + WD_FRAMERECT_LEFT, r.right - WD_FRAMERECT_LEFT, y += FONT_HEIGHT_NORMAL, STR_TOWN_VIEW_GENERATED_MAIL_LAST_MONTH_MAX);
+
+		/* Empty line. */
+		DrawString(r.left + WD_FRAMERECT_LEFT, r.right - WD_FRAMERECT_LEFT, y += FONT_HEIGHT_NORMAL, STR_EMPTY);
+
+		/* Transported goods rate of this town. Only displayed if we have enabled the town_growth_patch and the population is big enough. */
+		if (((!this->town->larger_town && _settings_game.economy.town_growth_cargo) || (this->town->larger_town && _settings_game.economy.larger_town_growth_cargo)) &&
+				((!this->town->larger_town && this->town->population > _settings_game.economy.town_pop_need_goods) ||
+				(this->town->larger_town && this->town->population > _settings_game.economy.larger_town_pop_need_goods))) {
+			/* Growth rate last month. */
+			SetDParam(0, this->town->GrowthRatePercent());
+			DrawString(r.left + WD_FRAMERECT_LEFT, r.right - WD_FRAMERECT_LEFT, y += FONT_HEIGHT_NORMAL, STR_TOWN_VIEW_GROWTH_RATE_LAST_MONTH);
+
+			/* Transported goods ratio last month. */
+			SetDParam(0, this->town->transported_goods_percent);
+			DrawString(r.left + WD_FRAMERECT_LEFT, r.right - WD_FRAMERECT_LEFT, y += FONT_HEIGHT_NORMAL, STR_TOWN_VIEW_TRANSPORTED_RATE_LAST_MONTH);
+
+			/* Most demanded for growth last month. */
+			str = STR_TOWN_VIEW_GROWTH_STANDARD;
+			if (_settings_game.economy.town_growth_rate == 0) {
+				str = STR_TOWN_VIEW_GROWTH_SPEED_DISABLED;
+			} else if (this->town->transported_goods_percent <= 99) {
+				str += this->town->needed_for_growth;
+				// long if else ... need to fetch the correct cago name -> grfs changing TE_xxx
+				if (this->town->needed_for_growth == GROWTH_NEED_STATION) {
+					str = STR_TOWN_VIEW_GROWTH_NEED_STATION;
+				} else if (this->town->needed_for_growth == GROWTH_NEED_MORE_PASS) {
+					SetDParam(1 , passengers_name);
+					str = STR_TOWN_VIEW_GROWTH_NEED_MORE_PASS;
+				} else if (this->town->needed_for_growth == GROWTH_NEED_MORE_MAIL) {
+					SetDParam(1 , mail_name);
+					str = STR_TOWN_VIEW_GROWTH_NEED_MORE_MAIL;
+				} else if (this->town->needed_for_growth == GROWTH_NEED_MORE_FOOD) {
+					SetDParam(1 , food_name);
+					str = STR_TOWN_VIEW_GROWTH_NEED_MORE_FOOD;
+				} else if (this->town->needed_for_growth == GROWTH_NEED_MORE_WATER) {
+					SetDParam(1 , water_name);
+					str = STR_TOWN_VIEW_GROWTH_NEED_MORE_WATER;
+				} else if (this->town->needed_for_growth == GROWTH_NEED_MORE_GOODS) {
+					SetDParam(1 , goods_name);
+					str = STR_TOWN_VIEW_GROWTH_NEED_MORE_GOODS;
+				} else if (this->town->needed_for_growth == GROWTH_NEED_PASS) {
+					SetDParam(1 , passengers_name);
+					str = STR_TOWN_VIEW_GROWTH_NEED_PASS;
+				} else if (this->town->needed_for_growth == GROWTH_NEED_MAIL) {
+					SetDParam(1 , mail_name);
+					str = STR_TOWN_VIEW_GROWTH_NEED_MAIL;
+				} else if (this->town->needed_for_growth == GROWTH_NEED_FOOD) {
+					SetDParam(1 , food_name);
+					str = STR_TOWN_VIEW_GROWTH_NEED_FOOD;}
+				else if (this->town->needed_for_growth == GROWTH_NEED_WATER) {
+					SetDParam(1 , water_name);
+					str = STR_TOWN_VIEW_GROWTH_NEED_WATER;
+				} else if (this->town->needed_for_growth == GROWTH_NEED_GOODS) {
+					SetDParam(1 , goods_name);
+					str = STR_TOWN_VIEW_GROWTH_NEED_GOODS;
+				} else {
+					SetDParam(1, STR_EMPTY);
+				}
+			} else if (this->town->transported_goods_percent >= 100) {
+				str = STR_TOWN_VIEW_GROWTH_SATISFIED;
+			}
+			SetDParam(0, str);
+			DrawString(r.left + WD_FRAMERECT_LEFT, r.right - WD_FRAMERECT_LEFT, y += FONT_HEIGHT_NORMAL, STR_TOWN_VIEW_CARGO_DEMAND_LAST_MONTH);
+
+			/* Empty line. */
+			DrawString(r.left + WD_FRAMERECT_LEFT, r.right - WD_FRAMERECT_LEFT, y += FONT_HEIGHT_NORMAL, STR_EMPTY);
+
+			/* Requirements "titel" (Needed to clarify that the values are this month's). */
+ 			DrawString(r.left + WD_FRAMERECT_LEFT, r.right - WD_FRAMERECT_LEFT, y += FONT_HEIGHT_NORMAL, STR_TOWN_VIEW_CARGO_FOR_TOWNGROWTH_THIS_MONTH);
+ 
+			/* Delivered and needed passengers. */
+			SetDParam(0, passengers_name);
+			SetDParam(1, this->town->act_pass);
+			SetDParam(2, this->town->max_pass);
+			DrawString(r.left + WD_FRAMERECT_LEFT, r.right - WD_FRAMERECT_LEFT, y += FONT_HEIGHT_NORMAL, STR_TOWN_VIEW_PASSENGERS_THIS_MONTH_MAX);
+
+			/* Delivered and needed mail. */
+			SetDParam(0, mail_name);
+			SetDParam(1, this->town->act_mail);
+			SetDParam(2, this->town->max_mail);
+			DrawString(r.left + WD_FRAMERECT_LEFT, r.right - WD_FRAMERECT_LEFT, y += FONT_HEIGHT_NORMAL, STR_TOWN_VIEW_MAIL_THIS_MONTH_MAX);
+
+			/* Delivered and needed food (Fizzy Drinks if we are playing in toyland). */
+			if ((_settings_game.game_creation.landscape == LT_ARCTIC && TilePixelHeight(this->town->xy) >= LowestSnowLine()) ||
+					(_settings_game.game_creation.landscape == LT_TROPIC && GetTropicZone(this->town->xy) == TROPICZONE_DESERT) ||
+					_settings_game.game_creation.landscape == LT_TOYLAND) {
+ 				SetDParam(0, food_name);
+ 				SetDParam(1, this->town->act_food);
+				SetDParam(2, this->town->max_food);
+				DrawString(r.left + WD_FRAMERECT_LEFT, r.right - WD_FRAMERECT_LEFT, y += FONT_HEIGHT_NORMAL, STR_TOWN_VIEW_FOOD_THIS_MONTH_MAX);
 			}
 
-			if (cargo_needed_for_growth > 1) {
-				if (first_water_cargo != CT_INVALID && this->town->act_water > 0) {
-					SetDParam(0, first_water_cargo);
-					SetDParam(1, this->town->act_water);
-					DrawString(cargo_text_left, cargo_text_right, y += FONT_HEIGHT_NORMAL, STR_TOWN_VIEW_CARGO_FOR_TOWNGROWTH_LAST_MONTH);
-				} else {
-					SetDParam(0, water_name);
-					DrawString(cargo_text_left, cargo_text_right, y += FONT_HEIGHT_NORMAL, required_text);
+			/* Delivered and needed water in desert. */
+			if (_settings_game.game_creation.landscape == LT_TROPIC && GetTropicZone(this->town->xy) == TROPICZONE_DESERT) {
+				SetDParam(0, water_name);
+				SetDParam(1, this->town->act_water);
+				SetDParam(2, this->town->max_water);
+				DrawString(r.left + WD_FRAMERECT_LEFT, r.right - WD_FRAMERECT_LEFT, y += FONT_HEIGHT_NORMAL, STR_TOWN_VIEW_WATER_THIS_MONTH_MAX);
+			}
+
+			/* Delivered and needed goods (Sweets if we play in toyland climate). */
+			SetDParam(0, goods_name);
+			SetDParam(1, this->town->act_goods);
+			SetDParam(2, this->town->max_goods);
+			DrawString(r.left + WD_FRAMERECT_LEFT, r.right - WD_FRAMERECT_LEFT, y += FONT_HEIGHT_NORMAL, STR_TOWN_VIEW_GOODS_THIS_MONTH_MAX);
+		}
+
+/* Old style gui 2/2 */
+		/* What is the town needing to be able to grow. */
+		if ((cargo_needed_for_growth > 0 &&
+				(((!this->town->larger_town && !_settings_game.economy.town_growth_cargo) || (this->town->larger_town && !_settings_game.economy.larger_town_growth_cargo)) ||
+				((!this->town->larger_town && _settings_game.economy.town_growth_cargo) || (this->town->larger_town && _settings_game.economy.larger_town_growth_cargo))) &&
+				((!this->town->larger_town && this->town->population < _settings_game.economy.town_pop_need_goods) ||
+				(this->town->larger_town && this->town->population < _settings_game.economy.larger_town_pop_need_goods)))) {
+			if (_settings_game.game_creation.landscape != LT_TEMPERATE && _settings_game.game_creation.landscape != LT_TOYLAND) {
+				bool rtl = _current_text_dir == TD_RTL;
+				uint cargo_text_left = r.left + WD_FRAMERECT_LEFT + (rtl ? 0 : 20);
+				uint cargo_text_right = r.right - WD_FRAMERECT_RIGHT - (rtl ? 20 : 0);
+
+				if (first_food_cargo != CT_INVALID && this->town->act_food > 0) {
+					SetDParam(0, first_food_cargo);
+					SetDParam(1, this->town->act_food);
+ 					DrawString(cargo_text_left, cargo_text_right, y += FONT_HEIGHT_NORMAL, STR_TOWN_VIEW_CARGO_FOR_TOWNGROWTH_LAST_MONTH);
+ 				} else {
+					SetDParam(0, food_name);
+ 					DrawString(cargo_text_left, cargo_text_right, y += FONT_HEIGHT_NORMAL, required_text);
+ 				}
+
+				if (cargo_needed_for_growth > 1) {
+					if (first_water_cargo != CT_INVALID && this->town->act_water > 0) {
+						SetDParam(0, first_water_cargo);
+						SetDParam(1, this->town->act_water);
+						DrawString(cargo_text_left, cargo_text_right, y += FONT_HEIGHT_NORMAL, STR_TOWN_VIEW_CARGO_FOR_TOWNGROWTH_LAST_MONTH);
+					} else {
+						SetDParam(0, water_name);
+						DrawString(cargo_text_left, cargo_text_right, y += FONT_HEIGHT_NORMAL, required_text);
+					}
 				}
-			}
-		}
+ 			}
+/* end old style gui 2/2 */
+ 		}
 
 		/* only show the town noise, if the noise option is activated. */
 		if (_settings_game.economy.station_noise_level) {
+			/* Empty line. */
+			DrawString(r.left + WD_FRAMERECT_LEFT, r.right - WD_FRAMERECT_LEFT, y += FONT_HEIGHT_NORMAL, STR_EMPTY);
+
 			SetDParam(0, this->town->noise_reached);
 			SetDParam(1, this->town->MaxTownNoise());
 			DrawString(r.left + WD_FRAMERECT_LEFT, r.right - WD_FRAMERECT_LEFT, y += FONT_HEIGHT_NORMAL, STR_TOWN_VIEW_NOISE_IN_TOWN);
@@ -572,7 +711,7 @@
 };
 
 static const WindowDesc _town_game_view_desc(
-	WDP_AUTO, 260, TownViewWindow::TVW_HEIGHT_NORMAL,
+	WDP_AUTO, 340, TownViewWindow::TVW_HEIGHT_NORMAL,
 	WC_TOWN_VIEW, WC_NONE,
 	WDF_UNCLICK_BUTTONS,
 	_nested_town_game_view_widgets, lengthof(_nested_town_game_view_widgets)
